<?php
/* function menulayout
 * Takes 6 arguments and outputs a HTML navigation menu
* $forwardLink = link to "next page", i.e. "nextPage.html"
* $backwardLink = link to "previous page", i.e. "previousPage.html"
* $downloadLink = link to download source file, on download button, i.e. "sourceFile.txt"
* headingLink = link in heading, i.e. "sourceFile.txt"
* fileContent = file containing info in the left panel, i.e. "panelContent.txt"
*/
function menulayout($forwardLink, $backwardLink, $downloadLink, $heading, $headingLink, $fileContent) {
	if($backwardLink != "") {
		$backwardButton = "<a href='".$backwardLink."'><img src='../media/codeviewer/CodeViewerLeftbutton.png'></a>";
	} else {
		$backwardButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
	}

	if($forwardLink != "") {
		$forwardButton = "<a href='".$forwardLink."'><img src='../media/codeviewer/CodeViewerRightbutton.png'></a>";
	} else {
		$forwardButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
	}

	if($downloadLink != "") {
		$downloadButton = "<a href='".$downloadLink."'><img src='../media/codeviewer/CodeViewerDownloadbutton.png'></a>";
	} else {
		$downloadButton = "<img src='../media/codeviewer/CodeViewerLeftbuttonGrayed.png'>";
	}

	echo '<body onload="resize();" onresize="resize();">
			<div class="Topmenu">
				<table style="width:100%;height:100%;border:solid 1px;">
					<tr>
						<td class="buttonstyle">
							'. $backwardButton .'
						</td>
						<td class="buttonstyle">
							'. $forwardButton .'
						</td>
						<td class="buttonstyle">
							<a href="../Lindex.html"><img src="../media/codeviewer/CodeViewerRightbutton.png"></a>
						</td>
						<td class="verticalaligntext">
							<a href="'. $headingLink .'" style="text-decoration: none">'. $heading .'</a>
						</td>
						<td class="buttonstyle">
							'. $downloadButton .'
						</td>
					</tr>
				</table>
			</div>
			<div id="bottom" class="restContainer">
				<div style="float: left;">
					<div id="panel" class="panel" onmousemove="resizepanel(event)" onmousedown="mdpanel(event)" onmouseup="mupanel(event)">';
						include($fileContent);
				echo '</div>
				</div>
			<div class="codecontent">';
}

/* function menulayoutend
 * Outputs ending tags in HTML
*/
function menulayoutEnd() {
	echo '</div>
		</div>
		<div style="clear: both;">
		</div>
	</body>';
}

/* function showfile
 * Outputs html with syntax highlighting.
* Takes 4 arguments_
* interestingRows: array containing arrays, each with 3 set values -- start line number, end line number, comment
* keywords: array containing keywords
* highlight: array containing arrays, each with two values - string to highlight, and HTML class to apply to highlight */
function showfile($interestingRows, $keywords, $highlight, $fileName) {
	echo "<pre>";
	$handle = @fopen($fileName, "r");
	if ($handle) {

		$lineNumber = 1;
		$commentKind = 0;
		$commentOn = 0;

		while (($buffer = fgets($handle, 4096)) !== false) {
			$buffer = str_replace("\n", "", $buffer);
			$buffer = str_replace("\r", "", $buffer);
			$buffer = str_pad($buffer, 150, " ", STR_PAD_RIGHT);
			$buffer = str_replace("&", "&amp;", $buffer);
			$buffer = str_replace("<", "&lt;", $buffer);
			$buffer = str_replace(">", "&gt;", $buffer);
			$buffer = str_replace("\t", "&nbsp;", $buffer);

			$interesting = 0;
			$startspan = 0;
			foreach($interestingRows as $row) {
				if($lineNumber >= $row[0] && $lineNumber <= $row[1]) {
					$interesting = true;
				}
			}

			foreach($keywords as $keyword) {
				if($interesting) {
					$buffer = str_replace($keyword,"<span class='keywordinteresting'>".$keyword."</span>", $buffer);
				} else {
					$buffer = str_replace($keyword,"<span class='keyword'>".$keyword."</span>", $buffer);
				}
			}

			// Detect comments - 0 == No comment 1 == Line comment 2 == Start Comment 3 == End Comment
			$commentKind = 0;
			$commentPos = strpos($buffer,"/*");

			if($commentPos >= 0) {
				$subby = substr($buffer, $commentPos+2, 1);
			} else {
				$subby = "Foo";
			}

			if($commentPos && $subby != '"') {
				$commentKind = 2;
				$commentOn = 1;
			}

			$commentPos = strpos($buffer, "*/");

			if($commentPos) {
				$commentKind = 3;
				$commentOn = 0;
			}

			$commentPos=strpos($buffer, "//");

			if($commentPos) {
				$commentKind = 1;
				$commentOn = 0;
			}

			foreach($highlight as $highlightkeyword) {
				$foundpos = strpos($buffer, $highlightkeyword[0]);

				// If line comment and keyword before comment marker
				if(($foundpos <= $commentPos && ($commentKind == 1 || $commentKind == 2)) || ($commentKind == 0) || ($foundpos > $commentPos && $commentKind == 3)) {
					if(!($commentKind == 0 && $commentOn == 1)) {
						$buffer = str_replace($highlightkeyword[0], "<span class='".$highlightkeyword[1]."'>".$highlightkeyword[0]."</span>", $buffer);
					}
				}

			}

			// echo $commentKind.$commentOn;
			if($commentKind > 0) {
				if($commentKind == 1) {
					$buffer = str_replace("//","<span class='commented'>//", $buffer);
					$buffer .= "</span>";
				}
				if($commentKind == 2) {
					$buffer=str_replace("/*","<span class='commented'>/*", $buffer);
				}
				if($commentKind == 3) {
					$buffer=str_replace("*/","*/</span>", $buffer);
				}
			}

			$linenostr = $lineNumber;
			$linenostr = str_pad($linenostr, 3, " ", STR_PAD_RIGHT);

			if($interesting) {
				echo "<span class='interesting'>";
				echo "<span class='linenointeresting'>".$linenostr."</span>&nbsp;";
				$startspan = 1;
			} else {
				echo "<span class='lineno'>".$linenostr."</span>&nbsp;";
			}

			echo $buffer;

			if($startspan) {
				echo "</span>";
			}

			$lineNumber++;
			echo "<br>";
		}
		if (!feof($handle)) {
			echo "Error: unexpected fgets() fail\n";
		}
		fclose($handle);
	}
	echo "</pre>";
}
?>